#----------------------------------------------------#
# This script runs every game tick.
# All the map specific commands are called from here.
#
# Scripter: Liontack
# Called by tag: #main:tick
#----------------------------------------------------#



### All items with the tag 'NoPickup' can never be picked up (COMMAND BLOCK FOR SAFETY!)
#execute as @e[type=item, tag=NoPickup] run data modify entity @s PickupDelay set value 111
#execute as @e[type=item, tag=NoPickup] run data modify entity @s Age set value 111

### Cast test rays
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:1}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:2}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:3}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:4}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:5}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:6}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:7}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:8}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:9}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:10}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:11}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:12}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:13}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:14}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:15}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:16}}}] run function main:ray/cast_test_block
execute as @e[scores={custom_click=1..}] at @s if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick", tag:{Damage:17}}}] run function main:ray/cast_test_entity

scoreboard players set @e[scores={custom_click=1..}] custom_click 0



### Update the map whenever an action is detected
function main:update_level/update_all


### Levitate players in the levitation tube
execute as @p[x=-23, y=65, z=-1, dx=2, dy=16, dz=2] run effect give @s levitation 9999 3
execute as @p[x=-20, y=65, z=-1, dx=2, dy=16, dz=2] run effect clear @s levitation



### Keep track of the time
execute if score b_run_time variables matches 1 run scoreboard players add i_time_t variables 1

execute if score b_run_time variables matches 1 if score i_time_t variables matches 20 run scoreboard players add i_time_s variables 1
execute if score b_run_time variables matches 1 if score i_time_t variables matches 20 run scoreboard players set i_time_t variables 0

execute if score b_run_time variables matches 1 if score i_time_s variables matches 60 run scoreboard players add i_time_m variables 1
execute if score b_run_time variables matches 1 if score i_time_s variables matches 60 run scoreboard players set i_time_s variables 0

execute if score b_run_time variables matches 1 if score i_time_m variables matches 60 run scoreboard players add i_time_h variables 1
execute if score b_run_time variables matches 1 if score i_time_m variables matches 60 run scoreboard players set i_time_m variables 0

execute if score i_time_h variables matches 1.. run title @a actionbar [{"color":"gold", "text":"Time "}, {"score":{"name":"i_time_h","objective":"variables"}}, {"text":":"}, {"score":{"name":"i_time_m","objective":"variables"}}, {"text":":"}, {"score":{"name":"i_time_s","objective":"variables"}}, {"color":"black", "text":" - "}, {"color":"gold", "text":"Level "}, {"score":{"name":"i_room","objective":"variables"}}, {"text":"/23"}]
execute if score i_time_h variables matches 0 if score i_time_m variables matches 10.. if score i_time_s variables matches 10.. run title @a actionbar [{"color":"gold", "text":"Time "}, {"score":{"name":"i_time_m","objective":"variables"}}, {"text":":"}, {"score":{"name":"i_time_s","objective":"variables"}}, {"color":"black", "text":" - "}, {"color":"gold", "text":"Level "}, {"score":{"name":"i_room","objective":"variables"}}, {"text":"/23"}]
execute if score i_time_h variables matches 0 if score i_time_m variables matches 0..9 if score i_time_s variables matches 10.. run title @a actionbar [{"color":"gold", "text":"Time 0"}, {"score":{"name":"i_time_m","objective":"variables"}}, {"text":":"}, {"score":{"name":"i_time_s","objective":"variables"}}, {"color":"black", "text":" - "}, {"color":"gold", "text":"Level "}, {"score":{"name":"i_room","objective":"variables"}}, {"text":"/23"}]
execute if score i_time_h variables matches 0 if score i_time_m variables matches 10.. if score i_time_s variables matches 0..9 run title @a actionbar [{"color":"gold", "text":"Time "}, {"score":{"name":"i_time_m","objective":"variables"}}, {"text":":0"}, {"score":{"name":"i_time_s","objective":"variables"}}, {"color":"black", "text":" - "}, {"color":"gold", "text":"Level "}, {"score":{"name":"i_room","objective":"variables"}}, {"text":"/23"}]
execute if score i_time_h variables matches 0 if score i_time_m variables matches 0..9 if score i_time_s variables matches 0..9 run title @a actionbar [{"color":"gold", "text":"Time 0"}, {"score":{"name":"i_time_m","objective":"variables"}}, {"text":":0"}, {"score":{"name":"i_time_s","objective":"variables"}}, {"color":"black", "text":" - "}, {"color":"gold", "text":"Level "}, {"score":{"name":"i_room","objective":"variables"}}, {"text":"/23"}]
execute if score i_time_h variables matches 0 if score i_time_m variables matches 0 if score i_time_s variables matches 10.. run title @a actionbar [{"color":"gold", "text":"Time 00:"}, {"score":{"name":"i_time_s","objective":"variables"}}, {"color":"black", "text":" - "}, {"color":"gold", "text":"Level "}, {"score":{"name":"i_room","objective":"variables"}}, {"text":"/23"}]
execute if score i_time_h variables matches 0 if score i_time_m variables matches 0 if score i_time_s variables matches 0..9 run title @a actionbar [{"color":"gold", "text":"Time 00:0"}, {"score":{"name":"i_time_s","objective":"variables"}}, {"color":"black", "text":" - "}, {"color":"gold", "text":"Level "}, {"score":{"name":"i_room","objective":"variables"}}, {"text":"/23"}]
